//mIRCSize.dll v1.5 by mr.man (c)2007

#pragma check_stack(off)
#pragma comment(linker,"/OPT:NOWIN98")

#include <windows.h>

#define WIN32_LEAN_AND_MEAN
#define mIRC(x) int __stdcall WINAPI x(HWND mWnd,HWND aWnd,char *data,char*,BOOL,BOOL)
#define Proc(x) LRESULT CALLBACK x(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
#define Ret(x) { lstrcpy(data,x); lstrcat(data,"\0"); return 3; }

HANDLE hFileMap;
LPSTR mData;
HWND mWnd;
HWND monitored_hwnds[999];
WNDPROC monitored_old_procs[999];
int monitored_count = 0;
long MIN_W = 200;
long MIN_H = 200;
long MAX_W = 800;
long MAX_H = 600;
int winsize_count = 0;

typedef struct
{
	HWND   aHwnd;
	long    MIN_W;
	long    MIN_H;
	long    MAX_W;
	long    MAX_H;
} WINSIZE;

WINSIZE win_constraints[999];

typedef struct 
{
	DWORD  mVersion;
	HWND   mHwnd;
	BOOL   mKeep;
} LOADINFO;

// Sends Signal to mIRC
void Signal(char *data);
// Removes window style to a window
void RemStyles(HWND hwnd,int parm,long RemStyles);
// Adds window styles to a window
void AddStyles(HWND hwnd,int parm,long AddStyles);
// GetTok Routine
char* GetTok(char *data, int pos, char *C, int all = 0);
// NumTok Routine
int NumTok(char *data, char *C);

// Sends Signal to mIRC
void Signal(char *data) {	
  wsprintf(mData,"//.signal -n mIRCSize %s",data);
  SendMessage(mWnd, WM_USER + 200,0,0);
}

// Removes window style to a window
void RemStyles(HWND hwnd,int parm,long RemStyles)
{
  LONG Styles = GetWindowLong(hwnd, parm);
  Styles &= ~RemStyles;
  SetWindowLong(hwnd, parm, Styles);
}

// Adds window styles to a window
void AddStyles(HWND hwnd,int parm,long AddStyles)
{
  LONG Styles = GetWindowLong(hwnd, parm);
  Styles |= AddStyles;
  SetWindowLong(hwnd, parm, Styles);
}

// GetTok Routine
char* GetTok(char *data, int pos, char *C, int all)
{
    char* Token;
    int i;
    char data2[1024];
    lstrcpy(data2,data);
    Token = strtok(data2,C);
    for (i = 1; Token && (i < pos); i++) {

      if (i == (pos-1) && all) return strtok(NULL,"");
      else Token = strtok(NULL,C);
    }
    if (all) return strtok(data,"");
    return Token;
}


void WINAPI LoadDll(LOADINFO *mIRC)
{
	mWnd = mIRC->mHwnd;
	hFileMap = CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,4096,"mIRC");	
	mData = (LPSTR)MapViewOfFile(hFileMap,FILE_MAP_ALL_ACCESS,0,0,0);
}

int WINAPI UnloadDll(int timeout)
{
	if (!timeout)
	{
		for (int i=0;i<monitored_count;i++) {
			SetWindowLong(monitored_hwnds[i],GWL_WNDPROC,(LONG)monitored_old_procs[i]);
		}
		UnmapViewOfFile(mData);
		CloseHandle(hFileMap);
	}
	return 0;
}

bool is_monitored(HWND hwnd) 
{
	for (int i=0;i<monitored_count;i++) {
		if (monitored_hwnds[i] == hwnd)
			return true;
	}
	return false;
}
WNDPROC get_old_proc(HWND hwnd) 
{
	for (int i=0;i<monitored_count;i++) {
		if (monitored_hwnds[i] == hwnd)
			return monitored_old_procs[i];
	}
	return NULL;
}

Proc(mIRCProc)
{
	WNDPROC old_proc = get_old_proc(hwnd);
	switch (uMsg) {
    case WM_GETMINMAXINFO: 
      {
		  bool is_constrained = false;
		  for (int i=0;i<999;i++)
		  {
			if (win_constraints[i].aHwnd == hwnd)
			{
				MIN_W = win_constraints[i].MIN_W;
				MIN_H = win_constraints[i].MIN_H;
				MAX_W = win_constraints[i].MAX_W;
				MAX_H = win_constraints[i].MAX_H;
				is_constrained = true;
			}
		  }  
		  if (is_constrained == true)
		  {		  
			MINMAXINFO *MMI; 
			MMI = (MINMAXINFO *)lParam; 
	        MMI->ptMinTrackSize.x = MIN_W;
		    MMI->ptMinTrackSize.y = MIN_H; 
			MMI->ptMaxTrackSize.x = MAX_W;
	        MMI->ptMaxTrackSize.y = MAX_H;
			Signal("RESIZE");
		  }
        return 0L;
      }
      break;
 	}
	return CallWindowProc(old_proc,hwnd,uMsg,wParam,lParam);
}


mIRC(constrain_win)
{
	HWND hwnd = (HWND)atol(data);
	if (is_monitored(hwnd)) {
		Ret("Already constraining this Window.");
	}
	monitored_hwnds[monitored_count] = hwnd;
	monitored_old_procs[monitored_count] = (WNDPROC)GetWindowLong(hwnd,GWL_WNDPROC);
	monitored_count++;
	SetWindowLong(hwnd,GWL_WNDPROC,(LONG)mIRCProc);
	Ret("Now constraining...");
}

mIRC(release_win)
{
	HWND hwnd = (HWND)atol(data);
	if (!IsWindow(hwnd)) { 
		Ret("This is an invalid window.");
	}
	if (!is_monitored(hwnd)) {
		Ret("Not constraining this window.");
	}
	SetWindowLong(hwnd,GWL_WNDPROC,(LONG)get_old_proc(hwnd));
	Ret("Window released.");
}

// Return Dll Info
mIRC(info) 
{
  Ret("mIRCSize.dll v1.5 by mr.man (c) 2007");
}

// Turn Resizing Off
mIRC(resize_off) 
{
  RemStyles(mWnd,GWL_STYLE,WS_THICKFRAME);
  return 0;
}

// Turn Resizing On
mIRC(resize_on) 
{
  AddStyles(mWnd,GWL_STYLE,WS_THICKFRAME);
  return 0;
}

// Set Window Constraints
mIRC(set_constraints) 
{
	
  int counter = 0;
  bool exists = false;
  char* win;
  MIN_W = atoi(GetTok(data,1," ",0));
  MIN_H = atoi(GetTok(data,2," ",0));
  MAX_W = atoi(GetTok(data,3," ",0));
  MAX_H = atoi(GetTok(data,4," ",0));
  win = GetTok(data,5," ",0);
  HWND hwnd = (HWND)atol(win);
  for (int i=0;i<999;i++) {
	if (win_constraints[i].aHwnd == hwnd)
	{
		win_constraints[i].MIN_W = MIN_W;
		win_constraints[i].MIN_H = MIN_H;
		win_constraints[i].MAX_W = MAX_W;
		win_constraints[i].MAX_H = MAX_H;
		exists = true;
	}
  }
  if (exists == false) {
	winsize_count++;
	win_constraints[winsize_count].aHwnd = hwnd;
	win_constraints[winsize_count].MIN_W = MIN_W;
	win_constraints[winsize_count].MIN_H = MIN_H;
	win_constraints[winsize_count].MAX_W = MAX_W;
	win_constraints[winsize_count].MAX_H = MAX_H;
  }
  Ret("Constraints Set OK");
}

// Set Window Size and Position
mIRC(set_size)
{
  int x,y,w,h,f;
  char* win;
  x = atoi(GetTok(data,1," ",0));
  y = atoi(GetTok(data,2," ",0));
  w = atoi(GetTok(data,3," ",0));
  h = atoi(GetTok(data,4," ",0));
  f = atoi(GetTok(data,5," ",0));
  win = GetTok(data,6," ",0);
  HWND hwnd = (HWND)atol(win);
  if (f == 0)
  {
	  SetWindowPos(hwnd,0,x,y,w,h,0);
  }
  else if (f == 1)
  {
	  SetWindowPos(hwnd,0,x,y,w,h,SWP_NOSIZE);
  }
  else if (f == 2)
  {
	  SetWindowPos(hwnd,0,x,y,w,h,SWP_NOMOVE);
  }
  return 0;
}



